﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;

namespace SemiColinGames {
  public sealed class ShmupWorld : IWorld {
    public class ShmupPlayer {
      public TextureRef Texture = Textures.Yellow2;
      // Center of player sprite.
      public Vector2 Position = new Vector2(32, 1080 / 8);
      public Vector2 HalfSize = new Vector2(16, 10);
    }

    public readonly Point Size;
    public readonly ShmupPlayer Player;

    public ShmupWorld() {
      Size = new Point(1920 / 4, 1080 / 4);
      Player = new ShmupPlayer();
    }

    ~ShmupWorld() {
      Dispose();
    }

    public void Dispose() {
      GC.SuppressFinalize(this);
    }

    public void Update(float modelTime, History<Input> input) {
      float speed = 150f;
      Vector2 motion = Vector2.Multiply(input[0].Motion, modelTime * speed);
      Player.Position = Vector2.Add(Player.Position, motion);
      Player.Position.X = Math.Max(Player.Position.X, Player.HalfSize.X);
      Player.Position.X = Math.Min(Player.Position.X, Size.X - Player.HalfSize.X);
      Player.Position.Y = Math.Max(Player.Position.Y, Player.HalfSize.Y);
      Player.Position.Y = Math.Min(Player.Position.Y, Size.Y - Player.HalfSize.Y);

    }
  }
}
